shader_type canvas_item;
render_mode blend_disabled;

uniform float iTime;
uniform int iFrame;
uniform sampler2D iChannel0;
uniform vec2 eposx;
uniform float anim_time;


// I do not like shadertoy "shockwave" effects, there many /0 errors, this modified without errors
void mainImage( out vec4 fragColor, in vec2 fragCoord,  in vec2 iResolution )
{
	vec2 fbo_res=vec2(1280,720);
	fbo_res=iResolution/fbo_res;
	vec2 epos=(eposx)/vec2(1280,720)-fbo_res/2.;
	epos.y=epos.y;
    float offset = fract(iTime/max(anim_time,0.01));
	float CurrentTime = max(offset,0.01);    
    
	vec3 WaveParams = vec3(10.0, 0.98, 0.1 ); 
    
    float ratio = iResolution.y/iResolution.x;
    
       
    vec2 WaveCentre = vec2(0.5, 0.5);
    WaveCentre.y *= ratio; 
   
	vec2 texCoord = fragCoord.xy / iResolution.xy;      
    texCoord.y *= ratio;    
    vec2 uv=texCoord-vec2(0.5,0.5*ratio);
	float d=smoothstep(0.5,0.35,length(uv));
	d*=1.-smoothstep(max(anim_time,0.01)/3.,max(anim_time,0.02),iTime);
	float Dist = distance(texCoord, WaveCentre);

	vec4 Color = texture(iChannel0, vec2((texCoord*fbo_res+epos).x,1.-(texCoord*fbo_res+epos).y));

if ((Dist <= ((CurrentTime) + (WaveParams.z))) && 
	(Dist >= ((CurrentTime) - (WaveParams.z)))) 
	{
		float Diff = (Dist - CurrentTime); 
		float ScaleDiff = (1.0 - pow(abs(Diff * WaveParams.x), WaveParams.y)); 
		float DiffTime = (Diff  * ScaleDiff);
        
		vec2 DiffTexCoord = normalize(texCoord - WaveCentre);         
        
		texCoord += d*((DiffTexCoord * DiffTime) / (CurrentTime * Dist * 40.0));
		Color = texture(iChannel0, vec2((texCoord*fbo_res+epos).x,1.-(texCoord*fbo_res+epos).y));
        
		Color += d*(Color * ScaleDiff) / (CurrentTime * Dist * 40.0);
	} 
    
	fragColor = vec4(Color.rgb,d); 
}

void fragment(){
	vec2 iResolution=floor(1./TEXTURE_PIXEL_SIZE);
	mainImage(COLOR,UV*iResolution,iResolution);
}