shader_type canvas_item;
render_mode blend_disabled;

uniform sampler2D iChannel0;
uniform sampler2D iChannel1;
uniform float expl_time;
uniform vec2 draw_at;


void mainImage( out vec4 fragColor, in vec2 fragCoord , in vec2 iResolution)
{
	vec2 paint_res=vec2(256);
	vec2 uv=fragCoord/iResolution;
	vec2 da=((fragCoord-draw_at)/paint_res)+0.5;
	vec3 col=vec3(0.);
	if(expl_time<0.3){
		if((da.x>0.)&&(da.y>0.)&&(da.x<1.)&&(da.y<1.))col=texture(iChannel1,da).rgb*texture(iChannel1,da).a;
	}
	col+=texture(iChannel0,uv).rgb*0.998;
	col=clamp(col,vec3(0.),vec3(1.));
   fragColor = vec4(col, 1);
}


void fragment(){
	vec2 iResolution=floor(1./TEXTURE_PIXEL_SIZE);
	mainImage(COLOR,UV*iResolution,iResolution);
}